Package: groovy.lang

## [Java] Class GroovyClassLoader

- groovy.lang.GroovyClassLoader

-     public class GroovyClassLoader
      extends URLClassLoader

  A ClassLoader which can load Groovy classes. The loaded classes are cached, classes from other classloaders should not be cached. To be able to load a script that was asked for earlier but was created later it is essential not to keep anything like a "class not found" information for that class name. This includes possible parent loaders. Classes that are not cached are always reloaded.

- - ### Nested Class Summary

    Nested classes
    Modifiers | Name | Description
    --- | --- | ---
    `static class` | `GroovyClassLoader.ClassCollector` | Collects classes defined during a compilation unit callback.
    `static class` | `GroovyClassLoader.InnerLoader` | Loader used while defining classes during a compilation round.

  - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `protected EvictableCache<String, Class>` | `classCache` | This cache contains the loaded classes or PARSING, if the class is currently parsed.
    `protected FlexibleCache<String, Class>` | `sourceCache` | This cache contains mappings of file name to class.

  - ### Constructor Summary

    Constructors
    Constructor and description
    `GroovyClassLoader()` Creates a GroovyClassLoader using the current Thread's context ClassLoader as parent.
    `GroovyClassLoader(ClassLoader parent)` Creates a GroovyClassLoader using the given ClassLoader as parent.
    `GroovyClassLoader(GroovyClassLoader parent)` Creates a GroovyClassLoader using the given GroovyClassLoader as parent.
    `GroovyClassLoader(ClassLoader parent, CompilerConfiguration config)` Creates a GroovyClassLoader using the given ClassLoader as parent.
    `GroovyClassLoader(ClassLoader parent, CompilerConfiguration config, boolean useConfigurationClasspath)` Creates a GroovyClassLoader with the default sourceCache.
    `GroovyClassLoader(ClassLoader parent, CompilerConfiguration config, boolean useConfigurationClasspath, FlexibleCache<String, Class> sourceCache)` Creates a GroovyClassLoader with a custom sourceCache.

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public void` | `addClasspath(String path)` adds a classpath to this classloader.
    `` | `public void` | `addURL(URL url)` adds a URL to the classloader.
    `` | `public void` | `clearCache()` Removes all classes from the class cache.
    `` | `public void` | `close()` Closes this GroovyClassLoader and clears any caches it maintains.
    `` | `protected GroovyClassLoader.ClassCollector` | `createCollector(CompilationUnit unit, SourceUnit su)` creates a ClassCollector for a new compilation.
    `` | `protected CompilationUnit` | `createCompilationUnit(CompilerConfiguration config, CodeSource source)` creates a new CompilationUnit.
    `` | `public Class` | `defineClass(String name, byte[] bytes)` Converts an array of bytes into an instance of `Class`.
    `` | `public Class` | `defineClass(ClassNode classNode, String file, String newCodeBase)` Compiles the given `ClassNode` returning the resulting `Class`.
    `` | `public String` | `genEncodingString(CharSequence chars)` Generates an encoded string based on the specified characters and the defined encoding algorithm.
    `` | `public String` | `generateScriptName()` Generates a unique script name for unnamed parsed sources.
    `` | `protected Class` | `getClassCacheEntry(String name)` gets a class from the class cache.
    `` | `protected String[]` | `getClassPath()` gets the currently used classpath.
    `` | `public Class[]` | `getLoadedClasses()`
    `` | `protected PermissionCollection` | `getPermissions(CodeSource codeSource)` Returns the permissions for the given codesource object. The implementation of this method first calls super.getPermissions and then adds permissions based on the URL of the codesource. If the protocol of this URL is "jar", then the permission granted is based on the permission that is required by the URL of the Jar file. If the protocol is "file" and there is an authority component, then permission to connect to and accept connections from that authority may be granted. If the protocol is "file" and the path specifies a file, then permission to read that file is granted. If protocol is "file" and the path is a directory, permission is granted to read all files and (recursively) all files and subdirectories contained in that directory. If the protocol is not "file", then permission to connect to and accept connections from the URL's host is granted. throws: NullPointerException if `codesource` is `null`. Parameters: `codesource` - the codesource Returns: the permissions granted to the codesource
    `` | `public GroovyResourceLoader` | `getResourceLoader()` Returns the resource loader used to resolve Groovy source by script name.
    `` | `protected long` | `getTimeStamp(Class cls)` Gets the time stamp of a given class.
    `` | `public boolean` | `hasCompatibleConfiguration(CompilerConfiguration config)` Checks if this class loader has compatible CompilerConfiguration with the provided one.
    `` | `protected boolean` | `isRecompilable(Class cls)` Indicates if a class is recompilable.
    `` | `public Boolean` | `isShouldRecompile()` gets the currently set recompilation mode. null means, the compiler configuration is used.
    `` | `protected boolean` | `isSourceNewer(URL source, Class cls)` Decides if the given source is newer than a class.
    `` | `public Class<?>` | `loadClass(String name)` Loads the class with the specified binary name. This method searches for classes in the same manner as the loadClass(String, boolean) method. It is invoked by the Java virtual machine to resolve class references. Invoking this method is equivalent to invoking loadClass(name,. throws: ClassNotFoundException If the class was not found Parameters: `name` - The binary name of the class Returns: The resulting `Class` object
    `` | `protected Class<?>` | `loadClass(String name, boolean resolve)` Implemented here to check package access prior to returning an already-loaded class.
    `` | `public Class` | `loadClass(String name, boolean lookupScriptFiles, boolean preferClassOverScript)` Loads a class from a file or a parent loader.
    `` | `public Class` | `loadClass(String name, boolean lookupScriptFiles, boolean preferClassOverScript, boolean resolve)` Loads a class from a file or a parent loader.
    `` | `public Class` | `parseClass(File file)` Parses the given file into a Java class capable of being run
    `` | `public Class` | `parseClass(String text, String fileName)` Parses the given text into a Java class capable of being run
    `` | `public Class` | `parseClass(String text)` Parses the given text into a Java class capable of being run
    `` | `public Class` | `parseClass(Reader reader, String fileName)` Parses Groovy source read from a Reader.
    `` | `public Class` | `parseClass(GroovyCodeSource codeSource)` Parses Groovy source described by a GroovyCodeSource.
    `` | `public Class` | `parseClass(GroovyCodeSource codeSource, boolean shouldCacheSource)` Parses the given code source into a Java class.
    `` | `protected Class` | `recompile(URL source, String className, Class oldClass)` (Re)Compiles the given source.
    `` | `protected void` | `removeClassCacheEntry(String name)` removes a class from the class cache.
    `` | `protected void` | `setClassCacheEntry(Class cls)` sets an entry in the class cache.
    `` | `public void` | `setResourceLoader(GroovyResourceLoader resourceLoader)` Sets the resource loader used to resolve Groovy source by script name.
    `` | `public void` | `setShouldRecompile(Boolean mode)` sets if the recompilation should be enabled.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class URLClassLoader` | `clearAssertionStatus, close, equals, findResource, findResources, getClass, getDefinedPackage, getDefinedPackages, getName, getParent, getPlatformClassLoader, getResource, getResourceAsStream, getResources, getSystemClassLoader, getSystemResource, getSystemResourceAsStream, getSystemResources, getURLs, getUnnamedModule, hashCode, isRegisteredAsParallelCapable, loadClass, newInstance, newInstance, notify, notifyAll, resources, setClassAssertionStatus, setDefaultAssertionStatus, setPackageAssertionStatus, toString, wait, wait, wait`

- - ### Field Detail

    - #### protected final EvictableCache<String, Class> classCache

      This cache contains the loaded classes or PARSING, if the class is currently parsed.

    - #### protected final FlexibleCache<String, Class> sourceCache

      This cache contains mappings of file name to class. It is used to bypass compilation.

  - ### Constructor Detail

    - #### public GroovyClassLoader()

      Creates a GroovyClassLoader using the current Thread's context ClassLoader as parent.

    - #### public GroovyClassLoader(ClassLoader parent)

      Creates a GroovyClassLoader using the given ClassLoader as parent.

    - #### public GroovyClassLoader(GroovyClassLoader parent)

      Creates a GroovyClassLoader using the given GroovyClassLoader as parent. The new loader will get the parent's CompilerConfiguration.

    - #### public GroovyClassLoader(ClassLoader parent, CompilerConfiguration config)

      Creates a GroovyClassLoader using the given ClassLoader as parent.

    - #### public GroovyClassLoader(ClassLoader parent, CompilerConfiguration config, boolean useConfigurationClasspath)

      Creates a GroovyClassLoader with the default sourceCache.

      Parameters:
        `parent` - the parent class loader
        `config` - the compiler configuration
        `useConfigurationClasspath` - determines if the configurations classpath should be added

    - #### public GroovyClassLoader(ClassLoader parent, CompilerConfiguration config, boolean useConfigurationClasspath, FlexibleCache<String, Class> sourceCache)

      Creates a GroovyClassLoader with a custom sourceCache.

      Parameters:
        `parent` - the parent class loader
        `config` - the compiler configuration
        `useConfigurationClasspath` - determines if the configurations classpath should be added
        `sourceCache` - the source cache to use

  - ### Method Detail

    - #### public void addClasspath(String path)

      adds a classpath to this classloader.

      Parameters:
        `path` - is a jar file or a directory.
      See Also:
        addURL(URL)

    - #### public void addURL(URL url)

      adds a URL to the classloader.

      Parameters:
        `url` - the new classpath element

    - #### public void clearCache()

      Removes all classes from the class cache.

      In addition to internal caches this method also clears any previously set MetaClass information for the given set of classes being removed.

      See Also:
        getClassCacheEntry(String)
        setClassCacheEntry(Class)
        removeClassCacheEntry(String)

    - #### public void close()

      Closes this GroovyClassLoader and clears any caches it maintains.

      No use should be made of this instance after this method is invoked. Any classes that are already loaded are still accessible.

      throws:
        IOException
      See Also:
        URLClassLoader.close
        clearCache()
      Since:
        2.5.0

    - #### protected GroovyClassLoader.ClassCollector createCollector(CompilationUnit unit, SourceUnit su)

      creates a ClassCollector for a new compilation.

      Parameters:
        `unit` - the compilationUnit
        `su` - the SourceUnit
      Returns:
        the ClassCollector

    - #### protected CompilationUnit createCompilationUnit(CompilerConfiguration config, CodeSource source)

      creates a new CompilationUnit. If you want to add additional phase operations to the CompilationUnit (for example to inject additional methods, variables, fields), then you should overwrite this method.

      Parameters:
        `config` - the compiler configuration, usually the same as for this class loader
        `source` - the source containing the initial file to compile, more files may follow during compilation
      Returns:
        the CompilationUnit

    - #### public Class defineClass(String name, byte[] bytes)

      Converts an array of bytes into an instance of `Class`. Before the class can be used it must be resolved.

    - #### public Class defineClass(ClassNode classNode, String file, String newCodeBase)

      Compiles the given `ClassNode` returning the resulting `Class`.

      WARNING: compilation is not synchronized

    - #### public String genEncodingString(CharSequence chars)

      Generates an encoded string based on the specified characters and the defined encoding algorithm. Supported algorithms currently are "md5" and sha256". An exception is throw for an unknown algorithm or if the JVM doesn't support the algorithm.

      Parameters:
        `chars` - The characters to encode.
      Returns:
        The encoded string.

    - #### public String generateScriptName()

      Generates a unique script name for unnamed parsed sources.

      Returns:
        a unique script name ending in `.groovy`

    - #### protected Class getClassCacheEntry(String name)

      gets a class from the class cache. This cache contains only classes loaded through this class loader or an InnerLoader instance. If no class is stored for a specific name, then the method should return null.

      Parameters:
        `name` - of the class
      Returns:
        the class stored for the given name
      See Also:
        removeClassCacheEntry(String)
        setClassCacheEntry(Class)
        clearCache()

    - #### protected String[] getClassPath()

      gets the currently used classpath.

      Returns:
        a String[] containing the file information of the urls
      See Also:
        getURLs()

    - #### public Class[] getLoadedClasses()

      Returns all Groovy classes loaded by this class loader.

      Returns:
        all classes loaded by this class loader

    - #### protected PermissionCollection getPermissions(CodeSource codeSource)

      Returns the permissions for the given codesource object. The implementation of this method first calls super.getPermissions and then adds permissions based on the URL of the codesource.

      If the protocol of this URL is "jar", then the permission granted is based on the permission that is required by the URL of the Jar file.

      If the protocol is "file" and there is an authority component, then permission to connect to and accept connections from that authority may be granted. If the protocol is "file" and the path specifies a file, then permission to read that file is granted. If protocol is "file" and the path is a directory, permission is granted to read all files and (recursively) all files and subdirectories contained in that directory.

      If the protocol is not "file", then permission to connect to and accept connections from the URL's host is granted.

      throws:
        NullPointerException if `codesource` is `null`.
      Parameters:
        `codesource` - the codesource
      Returns:
        the permissions granted to the codesource

    - #### public GroovyResourceLoader getResourceLoader()

      Returns the resource loader used to resolve Groovy source by script name.

      Returns:
        the current resource loader

    - #### protected long getTimeStamp(Class cls)

      Gets the time stamp of a given class. For groovy generated classes this usually means to return the value of the static field __timeStamp. If the parameter doesn't have such a field, then Long.MAX_VALUE is returned

      Parameters:
        `cls` - the class
      Returns:
        the time stamp

    - #### public boolean hasCompatibleConfiguration(CompilerConfiguration config)

      Checks if this class loader has compatible CompilerConfiguration with the provided one.

      Parameters:
        `config` - the compiler configuration to test for compatibility
      Returns:
        `true` if the provided config is exactly the same instance of CompilerConfiguration as this loader has

    - #### protected boolean isRecompilable(Class cls)

      Indicates if a class is recompilable. Recompilable means, that the classloader will try to locate a groovy source file for this class and then compile it again, adding the resulting class as entry to the cache. Giving null as class is like a recompilation, so the method should always return true here. Only classes that are implementing GroovyObject are compilable and only if the timestamp in the class is lower than Long.MAX_VALUE.

      NOTE: First the parent loaders will be asked and only if they don't return a class the recompilation will happen. Recompilation also only happen if the source file is newer.

      Parameters:
        `cls` - the class to be tested. If null the method should return true
      Returns:
        true if the class should be compiled again
      See Also:
        isSourceNewer(URL, Class)

    - #### public Boolean isShouldRecompile()

      gets the currently set recompilation mode. null means, the compiler configuration is used. False means no recompilation and true means that recompilation will be done if needed.

      Returns:
        the recompilation mode

    - #### protected boolean isSourceNewer(URL source, Class cls)

      Decides if the given source is newer than a class. Last-modified is read via URLStreams.getLastModified. A class is considered current until the source is newer by more than CompilerConfiguration.getMinimumRecompilationInterval.

      throws:
        IOException if it is not possible to open a connection for the given source
      Parameters:
        `source` - the source we may want to compile
        `cls` - the former class
      Returns:
        true if the source is newer, false else
      See Also:
        getTimeStamp(Class)

    - #### public Class<?> loadClass(String name)

      Loads the class with the specified binary name. This method searches for classes in the same manner as the loadClass(String, boolean) method. It is invoked by the Java virtual machine to resolve class references. Invoking this method is equivalent to invoking loadClass(name,.

      throws:
        ClassNotFoundException If the class was not found
      Parameters:
        `name` - The binary name of the class
      Returns:
        The resulting `Class` object
      See Also:
        ClassLoader#loadClass(java.lang.String,boolean)

    - #### protected Class<?> loadClass(String name, boolean resolve)

      Implemented here to check package access prior to returning an already-loaded class.

      throws:
        ClassNotFoundException if class could not be found
      throws:
        CompilationFailedException if compilation of script failed

    - #### public Class loadClass(String name, boolean lookupScriptFiles, boolean preferClassOverScript)

      Loads a class from a file or a parent loader. This method delegates to:

           loadClass(name, lookupScriptFiles, preferClassOverScript, false);

      throws:
        ClassNotFoundException if class could not be found
      throws:
        CompilationFailedException if compilation of script failed

    - #### public Class loadClass(String name, boolean lookupScriptFiles, boolean preferClassOverScript, boolean resolve)

      Loads a class from a file or a parent loader.

      throws:
        ClassNotFoundException if class could not be found
      throws:
        CompilationFailedException if compilation of script failed
      Parameters:
        `name` - of the class to be loaded
        `lookupScriptFiles` - if false no lookup at files is done at all
        `preferClassOverScript` - if true the file lookup is only done if there is no class
        `resolve` - see ClassLoader.loadClass
      Returns:
        the class found or the class created from a file lookup

    - #### public Class parseClass(File file)

      Parses the given file into a Java class capable of being run

      Parameters:
        `file` - the file name to parse
      Returns:
        the main class defined in the given script

    - #### public Class parseClass(String text, String fileName)

      Parses the given text into a Java class capable of being run

      Parameters:
        `text` - the text of the script/class to parse
        `fileName` - the file name to use as the name of the class
      Returns:
        the main class defined in the given script

    - #### public Class parseClass(String text)

      Parses the given text into a Java class capable of being run

      Parameters:
        `text` - the text of the script/class to parse
      Returns:
        the main class defined in the given script

    - #### public Class parseClass(Reader reader, String fileName)

      Parses Groovy source read from a Reader.

      throws:
        CompilationFailedException if compilation fails
      Parameters:
        `reader` - the reader supplying source text
        `fileName` - the logical script name
      Returns:
        the main class defined by the source

    - #### public Class parseClass(GroovyCodeSource codeSource)

      Parses Groovy source described by a GroovyCodeSource.

      throws:
        CompilationFailedException if compilation fails
      Parameters:
        `codeSource` - the code source to compile
      Returns:
        the main class defined by the source

    - #### public Class parseClass(GroovyCodeSource codeSource, boolean shouldCacheSource)

      Parses the given code source into a Java class. If there is a class file for the given code source, then no parsing is done, instead the cached class is returned.

      Parameters:
        `shouldCacheSource` - if true then the generated class will be stored in the source cache
      Returns:
        the main class defined in the given script

    - #### protected Class recompile(URL source, String className, Class oldClass)

      (Re)Compiles the given source. This method starts the compilation of a given source, if the source has changed since the class was created. For this isSourceNewer is called.

      throws:
        CompilationFailedException if the compilation failed
      throws:
        IOException if the source is not readable
      Parameters:
        `source` - the source pointer for the compilation
        `className` - the name of the class to be generated
        `oldClass` - a possible former class
      Returns:
        the old class if the source wasn't new enough, the new class else
      See Also:
        isSourceNewer(URL, Class)

    - #### protected void removeClassCacheEntry(String name)

      removes a class from the class cache.

      Parameters:
        `name` - of the class
      See Also:
        getClassCacheEntry(String)
        setClassCacheEntry(Class)
        clearCache()

    - #### protected void setClassCacheEntry(Class cls)

      sets an entry in the class cache.

      Parameters:
        `cls` - the class
      See Also:
        removeClassCacheEntry(String)
        getClassCacheEntry(String)
        clearCache()

    - #### public void setResourceLoader(GroovyResourceLoader resourceLoader)

      Sets the resource loader used to resolve Groovy source by script name.

      Parameters:
        `resourceLoader` - the resource loader to use

    - #### public void setShouldRecompile(Boolean mode)

      sets if the recompilation should be enabled. There are 3 possible values for this. Any value different from null overrides the value from the compiler configuration. true means to recompile if needed false means to never recompile.

      Parameters:
        `mode` - the recompilation mode
      See Also:
        CompilerConfiguration